futhark-0.25.32: An optimising compiler for a functional, array-oriented language.

Safe Haskell | None
Language | GHC2021

Futhark.CodeGen.ImpGen.GPU.SegScan.SinglePass

Description

Code generation for segmented and non-segmented scans. Uses a fast single-pass algorithm, but which only works on NVIDIA GPUs and with some constraints on the operator. We use this when we can.

Synopsis

- compileSegScan :: Pat LetDecMem -> SegLevel -> SegSpace -> SegBinOp GPUMem -> KernelBody GPUMem -> CallKernelGen ()

# Documentation

compileSegScan :: Pat LetDecMem -> SegLevel -> SegSpace -> SegBinOp GPUMem -> KernelBody GPUMem -> CallKernelGen () Source #

Compile `SegScan` instance to host-level code with calls to a single-pass kernel.